package uk.co.trinitylogic.skyfall.dao;

import java.util.List;

import uk.co.trinitylogic.skyfall.form.Member;
import uk.co.trinitylogic.skyfall.form.Service;

public interface MemberDAO {

	public void addMember(Member member);

	public void removeMember(Integer id);

	public void updateMember(Member member);

	public List<Member> listMember();

	public List<Member> listMembersForService(Service service);

	public Member getMember(Integer id);

	public List<Member> listMembersForMailServiceOptIn(Service service);

	public List<Member> listMembersForTextServiceOptIn(Service service);

	public List<Member> searchForMembers(String search);

	public Long memberCount();

	public List<Member> listDistinctMembersForMailServiceOptIn(
			List<Service> services);

	public List<Member> listDistinctMembersForTextServiceOptIn(
			List<Service> services);

	public List<Member> listDistinctMembersForServiceList(List<Service> services);

	public Member getMember(String email);

	public Long memberCountForService(Service service);

	public List<Member> listDistinctMembersForMailServiceDoubleOptIn(
			List<Service> services);
}
