package uk.co.trinitylogic.skyfall.dao;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

@Repository
@Transactional
public class SearchDAOImpl implements SearchDAO {

	protected final Log logger = LogFactory.getLog(getClass());

	@Autowired
	private SessionFactory sessionFactory;

	@Async
	@Override
	public void updateIndex() {
		try {
			SearchUtils.doIndexing(sessionFactory.getCurrentSession());
		} catch (HibernateException e) {
			logger.error("Problem with the database", e);
		} catch (InterruptedException e) {
			logger.error("update thread interuped", e);
		}
	}
}
