package uk.co.trinitylogic.skyfall.dao;

import org.hibernate.CacheMode;
import org.hibernate.classic.Session;
import org.hibernate.search.FullTextSession;
import org.hibernate.search.Search;
import org.springframework.scheduling.annotation.Async;

import uk.co.trinitylogic.skyfall.form.Advice;
import uk.co.trinitylogic.skyfall.form.Member;

public class SearchUtils {

	@Async
	public static void doIndexing(Session session) throws InterruptedException {
		FullTextSession fullTextSession = Search.getFullTextSession(session);
		fullTextSession.createIndexer(Member.class).batchSizeToLoadObjects(30)
				.threadsForSubsequentFetching(8).threadsToLoadObjects(4)
				.threadsForIndexWriter(3).cacheMode(CacheMode.NORMAL)
				.startAndWait();
		fullTextSession.createIndexer(Advice.class).batchSizeToLoadObjects(30)
				.threadsForSubsequentFetching(8).threadsToLoadObjects(4)
				.threadsForIndexWriter(3).cacheMode(CacheMode.NORMAL)
				.startAndWait();
	}
}
