package uk.co.trinitylogic.skyfall.dao;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import uk.co.trinitylogic.skyfall.form.Transaction;

@Repository
@Transactional
public class TransactionDAOImpl implements TransactionDAO {

	protected final Log logger = LogFactory.getLog(getClass());

	@Autowired
	private SessionFactory sessionFactory;

	@Override
	public void addTransaction(Transaction transaction) {
		logger.info("Adding a new transaction: " + transaction);
		long startTime = System.nanoTime();
		sessionFactory.getCurrentSession().save(transaction);
		long endTime = System.nanoTime();
		long duration = (endTime - startTime) / 1000000;
		logger.info("Added a new transaction: " + transaction + " Time: "
				+ duration + "ms");
	}

	@Override
	public List<Transaction> listTransaction() {
		logger.info("List all transactions");
		long startTime = System.nanoTime();
		@SuppressWarnings("unchecked")
		List<Transaction> result = sessionFactory
				.getCurrentSession()
				.createQuery(
						"select trans from Transaction trans order by trans.created desc")
				.setCacheable(true).list();
		long endTime = System.nanoTime();
		long duration = (endTime - startTime) / 1000000;
		logger.info("List all transactions Time: " + duration + "ms");
		return result;
	}

}
