package uk.co.trinitylogic.skyfall.form;

import java.util.Date;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;
import org.hibernate.validator.constraints.Email;
import org.hibernate.validator.constraints.NotEmpty;
import org.springframework.format.annotation.DateTimeFormat;

@Entity
@Table(name = "enquirers")
@Cacheable
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class Enquirer {

	@Transient
	protected final Log logger = LogFactory.getLog(getClass());

	@Id
	@GeneratedValue
	@Column(name = "idenquirers")
	private Integer enquirerId;

	@Column(name = "created")
	@DateTimeFormat(pattern = "dd/MM/yy")
	private final Date created = new Date();

	@Column(nullable = true, name = "unsubscribe")
	@DateTimeFormat(pattern = "dd/MM/yy")
	private Date unsubscribe;

	@Email
	@NotEmpty
	@Column(nullable = true, name = "email")
	private String email;

	@Column(nullable = true, name = "serviceId")
	private Integer serviceId;

	public Integer getEnquirerId() {
		return enquirerId;
	}

	public void setEnquirerId(Integer enquirerId) {
		this.enquirerId = enquirerId;
	}

	public Date getCreated() {
		return created;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Integer getServiceId() {
		return serviceId;
	}

	public void setServiceId(Integer serviceId) {
		this.serviceId = serviceId;
	}

	@Override
	public String toString() {
		return "[" + email + "] [" + serviceId + "] [" + created + "]";
	}

	public Date getUnsubscribe() {
		return unsubscribe;
	}

	public void setUnsubscribe(Date unsubscribe) {
		this.unsubscribe = unsubscribe;
	}

}
