package uk.co.trinitylogic.skyfall.form;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Entity
@Table(name = "members_has_services")
@AssociationOverrides({
		@AssociationOverride(name = "pk.member", joinColumns = @JoinColumn(name = "members_idmembers")),
		@AssociationOverride(name = "pk.service", joinColumns = @JoinColumn(name = "services_idservices")) })
@Cacheable
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class MemberServices {

	@EmbeddedId
	private MemberServicesId pk = new MemberServicesId();

	@Transient
	protected final Log logger = LogFactory.getLog(getClass());

	@Column(name = "member_service_type")
	private String memberServiceType;

	public MemberServicesId getPk() {
		return pk;
	}

	public void setPk(MemberServicesId pk) {
		this.pk = pk;
	}

	public String getMemberServiceType() {
		return memberServiceType;
	}

	public void setMemberServiceType(String memberServiceType) {
		this.memberServiceType = memberServiceType;
	}

	@Transient
	public Service getService() {
		return getPk().getService();
	}

	public void setService(Service service) {
		getPk().setService(service);
	}

	@Transient
	public Member getMember() {
		return getPk().getMember();
	}

	public void setMember(Member member) {
		getPk().setMember(member);
	}

	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || getClass() != o.getClass())
			return false;
		MemberServices that = (MemberServices) o;
		if (getPk() != null ? !getPk().equals(that.getPk())
				: that.getPk() != null)
			return false;

		return true;
	}

	@Override
	public int hashCode() {
		return (getPk() != null ? getPk().hashCode() : 0);
	}
}
