package uk.co.trinitylogic.skyfall.form;

import java.io.Serializable;

import javax.persistence.Cacheable;
import javax.persistence.Embeddable;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

@Embeddable
@Cacheable
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class MemberServicesId implements Serializable {

	private static final long serialVersionUID = 8138600072220266311L;

	@Transient
	protected final Log logger = LogFactory.getLog(getClass());

	@ManyToOne
	private Member member;

	@ManyToOne
	private Service service;

	public Member getMember() {
		return member;
	}

	public void setMember(Member member) {
		this.member = member;
	}

	public Service getService() {
		return service;
	}

	public void setService(Service service) {
		this.service = service;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || getClass() != o.getClass())
			return false;
		MemberServicesId that = (MemberServicesId) o;
		if (member != null ? !member.equals(that.member) : that.member != null)
			return false;
		if (service != null ? !service.equals(that.service)
				: that.service != null)
			return false;

		return true;
	}

	@Override
	public int hashCode() {
		int result;
		result = (member != null ? member.hashCode() : 0);
		result = 31 * result + (service != null ? service.hashCode() : 0);
		return result;
	}
}