package uk.co.trinitylogic.skyfall.form;

import java.text.DecimalFormat;
import java.util.List;

public class Report {

	private final Service service;
	private final List<Advice> advices;
	private String type;

	public Report(Service service, List<Advice> advices) {
		this.service = service;
		this.advices = advices;
	}

	public String getReportDetails() {
		int totalAdvices = advices.size();
		int winner = 0;
		int lossers = 0;
		double totalLspAtEp = 0;
		double totalLspAtBsp = 0;
		for (Advice a : advices) {
			if ("W".equalsIgnoreCase(a.getWonOrLost())) {
				winner++;
			} else {
				lossers++;
			}
			try {
				totalLspAtEp = totalLspAtEp + Double.valueOf(a.getLsAtEp());
			} catch (Exception e) {
			}
			try {
				totalLspAtBsp = totalLspAtBsp + Double.valueOf(a.getLspAtBsp());
			} catch (Exception e) {
			}
		}
		double strikeRate = ((double) winner / (double) totalAdvices) * 100;
		DecimalFormat df = new DecimalFormat("#.##");
		return service.getShortCode() + ": BETS[" + totalAdvices + "] WON["
				+ winner + "] LOST[" + lossers + "] STRIKE RATE["
				+ df.format(strikeRate) + "%] LSP@AO["
				+ df.format(totalLspAtEp) + "] LSP@BSP["
				+ df.format(totalLspAtBsp) + "]";
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
}
