package uk.co.trinitylogic.skyfall.service;

import java.util.Date;
import java.util.List;

import uk.co.trinitylogic.skyfall.form.Advice;
import uk.co.trinitylogic.skyfall.form.Member;
import uk.co.trinitylogic.skyfall.form.Service;

public interface AdviceService {

	public void addAdvice(Advice advice);

	public void removeAdvice(Integer id);

	public void updateAdvice(Advice advice);

	public List<Advice> listAdvice();

	public Advice getAdvice(Integer adviceId);

	public List<Advice> listDailyAdviceForService(Integer serviceId, Date today);

	public void sendMailAdviceForService(Service service, List<Advice> advices,
			List<Member> mailMembers, String mail);

	public void sendTextAdviceForService(Service service, List<Advice> advices,
			List<Member> textMembers, String text);

	public List<Advice> searchForAdvices(String search)
			throws InterruptedException;

	public List<Advice> listAdvicesForService(Service service, Date startDate,
			Date endDate);

	public List<Advice> listAllAdvicesForService(Service service);
}
