package uk.co.trinitylogic.skyfall.service;

import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uk.co.trinitylogic.skyfall.dao.EnquirerDAO;
import uk.co.trinitylogic.skyfall.form.Enquirer;

@Service
public class EnquirerServiceImpl implements EnquirerService {

	protected final Log logger = LogFactory.getLog(getClass());
	protected final Format formatter = new SimpleDateFormat("dd/MM/yy");

	@Autowired
	private EnquirerDAO enquirerDAO;

	@Override
	@Transactional
	public void addEnquirer(Enquirer enquirer) {
		enquirerDAO.addEnquirer(enquirer);
	}

	@Override
	public boolean hasEnquired(Enquirer enquirer) {
		return enquirerDAO.hasEnquired(enquirer);
	}

	@Override
	public Enquirer getEnquirer(Integer id) {
		return enquirerDAO.getEnquirer(id);
	}

	@Override
	public List<Enquirer> getEnquirer(String email) {
		return enquirerDAO.getEnquirer(email);
	}

	@Override
	public List<Enquirer> listEnquirer() {
		return enquirerDAO.listEnquirer();
	}

	@Override
	public List<Enquirer> listUnsubscribes() {
		return enquirerDAO.listUnsubscribes();
	}

	@Override
	@Transactional
	public void updateEnquirer(Enquirer enquirer) {
		enquirerDAO.updateEnquirer(enquirer);
	}
}
