package uk.co.trinitylogic.skyfall.service;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uk.co.trinitylogic.skyfall.dao.MemberDAO;
import uk.co.trinitylogic.skyfall.form.Member;

@Service
@Transactional
public class MemberServiceImpl implements MemberService {

	protected final Log logger = LogFactory.getLog(getClass());

	@Autowired
	private MemberDAO memberDAO;

	@Override
	public void addMember(Member member) {
		memberDAO.addMember(member);
	}

	@Override
	public void removeMember(Integer id) {
		memberDAO.removeMember(id);
	}

	@Override
	public void updateMember(Member member) {
		memberDAO.updateMember(member);
	}

	@Override
	public List<Member> listMember() {
		return memberDAO.listMember();
	}

	@Override
	public List<Member> listMembersForService(
			uk.co.trinitylogic.skyfall.form.Service service) {
		return memberDAO.listMembersForService(service);
	}

	@Override
	public Member getMember(Integer id) {
		return memberDAO.getMember(id);
	}

	@Override
	public List<Member> listMembersForMailServiceOptIn(
			uk.co.trinitylogic.skyfall.form.Service service) {
		return memberDAO.listMembersForMailServiceOptIn(service);
	}

	@Override
	public List<Member> listMembersForTextServiceOptIn(
			uk.co.trinitylogic.skyfall.form.Service service) {
		return memberDAO.listMembersForTextServiceOptIn(service);
	}

	@Override
	public List<Member> searchForMembers(String search) {
		return memberDAO.searchForMembers(search);
	}

	@Override
	public Long memberCount() {
		return memberDAO.memberCount();
	}

	@Override
	public Long memberCountForService(
			uk.co.trinitylogic.skyfall.form.Service service) {
		return memberDAO.memberCountForService(service);
	}

	@Override
	public List<Member> listDistinctMembersForMailServiceOptIn(
			List<uk.co.trinitylogic.skyfall.form.Service> services) {
		return memberDAO.listDistinctMembersForMailServiceOptIn(services);
	}

	@Override
	public List<Member> listDistinctMembersForTextServiceOptIn(
			List<uk.co.trinitylogic.skyfall.form.Service> services) {
		return memberDAO.listDistinctMembersForTextServiceOptIn(services);
	}

	@Override
	public List<Member> listDistinctMembersForServiceList(
			List<uk.co.trinitylogic.skyfall.form.Service> services) {
		return memberDAO.listDistinctMembersForServiceList(services);

	}

	@Override
	public Member getMember(String email) {
		return memberDAO.getMember(email);

	}

	@Override
	public List<Member> listDistinctMembersForMailServiceDoubleOptIn(
			List<uk.co.trinitylogic.skyfall.form.Service> services) {
		return memberDAO.listDistinctMembersForMailServiceDoubleOptIn(services);

	}
}
