package uk.co.trinitylogic.skyfall.service;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uk.co.trinitylogic.skyfall.dao.SearchDAO;

@Service
@Transactional
public class SearchServiceImpl implements SearchService {

	protected final Log logger = LogFactory.getLog(getClass());

	@Autowired
	private SearchDAO searchDAO;

	@Override
	@Async
	public void updateIndex() {
		searchDAO.updateIndex();
	}

	@Override
	@Scheduled(cron = "0 30 23 * * ?")
	public void runBaseLine() {
		logger.info("Cron set to: [0 30 23 * * ?]");
		searchDAO.updateIndex();
	}
}
