package uk.co.trinitylogic.skyfall.service;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import uk.co.trinitylogic.skyfall.dao.ServiceDAO;

@Service
@Transactional
public class ServiceServiceImpl implements ServiceService {

	protected final Log logger = LogFactory.getLog(getClass());

	@Autowired
	private ServiceDAO serviceDAO;

	@Override
	public void addService(uk.co.trinitylogic.skyfall.form.Service service) {
		serviceDAO.addService(service);
	}

	@Override
	public uk.co.trinitylogic.skyfall.form.Service getService(Integer id) {
		return serviceDAO.getService(id);
	}

	@Override
	public void removeService(Integer id) {
		serviceDAO.removeService(id);
	}

	@Override
	public void updateService(uk.co.trinitylogic.skyfall.form.Service service) {
		serviceDAO.updateService(service);
	}

	@Override
	public List<uk.co.trinitylogic.skyfall.form.Service> listService() {
		return serviceDAO.listService();
	}

	@Override
	public List<uk.co.trinitylogic.skyfall.form.Service> listLiveService() {
		return serviceDAO.listLiveService();
	}

	@Override
	public List<uk.co.trinitylogic.skyfall.form.Service> listLiveServiceWithMemberCount() {
		return serviceDAO.listServiceWithMemberCount();
	}

	@Override
	public void hideService(Integer id) {
		serviceDAO.hideService(id);
	}
}
