package uk.co.trinitylogic.skyfall.service;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

@Service
public class TxtServiceImpl implements TxtService {

	protected final Log logger = LogFactory.getLog(getClass());

	@Override
	@Async
	public void sendTxt(String number, String message) {
		sendLiveText(number, message);
	}

	private void sendLiveText(String number, String message) {
		try {

			URLConnection con = getTextUrl().openConnection();
			con.setDoOutput(true);
			OutputStreamWriter wr = new OutputStreamWriter(
					con.getOutputStream());
			wr.write(getEncodedData(number, message));
			wr.flush();
			BufferedReader rd = new BufferedReader(new InputStreamReader(
					con.getInputStream()));
			String line;
			String result = "";
			while ((line = rd.readLine()) != null) {
				result = result + line + " ";
			}
			logger.info(result);
			wr.close();
			rd.close();
		} catch (Exception e) {
			logger.error("Exception", e);
		}
	}

	@Async
	private URL getTextUrl() throws MalformedURLException {
		URL url = new URL(
				"https://secure.telecomstats.co.uk/SMSAPI/Scripts/SendText.aspx");
		return url;
	}

	@Async
	private String getEncodedData(String number, String message)
			throws UnsupportedEncodingException {
		String UTF8 = "UTF-8";
		String username = "goldcall";
		String password = "goldcall";
		String clientID = "5421";
		String route = "Standard";
		String validUntil = "";
		String network = "Any";
		String originator = "MattWalton";
		StringBuilder data = new StringBuilder();
		data.append("clientid=").append(URLEncoder.encode(clientID, UTF8))
				.append("&username=").append(URLEncoder.encode(username, UTF8))
				.append("&password=").append(URLEncoder.encode(password, UTF8))
				.append("&recipient=").append(URLEncoder.encode(number, UTF8))
				.append("&validUntil=")
				.append(URLEncoder.encode(validUntil, UTF8))
				.append("&message=").append(URLEncoder.encode(message, UTF8))
				.append("&route=").append(URLEncoder.encode(route, UTF8))
				.append("&network=").append(URLEncoder.encode(network, UTF8))
				.append("&originator=")
				.append(URLEncoder.encode(originator, UTF8));
		logger.info(data.toString());
		return data.toString();
	}
}
