<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">

<%@taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<form:form method="post" onSubmit="return shouldContinue()"
	action="add-member-submit" commandName="member">
	<table width="100%">
		<tr class="divider-bottom">
			<td width="100%" colspan="2"><div id="heading">
					<spring:message code="add-member.heading" />
				</div></td>
		</tr>
		<tr>
			<td width="100%" colspan="2"><form:errors path="*"
					cssClass="errorblock" element="div" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="title">
					<spring:message code="member.title" />
				</form:label></td>
			<td width="75%" ><form:select path="title">
					<form:option selected="selected" value="Mr">Mr</form:option>
					<form:option value="Dr">Dr</form:option>
					<form:option value="Mrs">Mrs</form:option>
					<form:option value="Ms">Ms</form:option>
					<form:option value="Miss">Miss</form:option>
					<form:option value="Prof">Prof</form:option>
					<form:option value="Cpt">Cpt</form:option>
				</form:select></td>
		<tr class="input">
			<td width="25%" ><form:label path="forename">
					<spring:message code="member.forename" />
				</form:label></td>
			<td width="75%" ><form:input path="forename" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="surname">
					<spring:message code="member.surname" />
				</form:label></td>
			<td width="75%" ><form:input path="surname" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="address1">
					<spring:message code="member.address_1" />
				</form:label></td>
			<td width="75%" ><form:input path="address1" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="address2">
					<spring:message code="member.address_2" />
				</form:label></td>
			<td width="75%" ><form:input path="address2" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="town">
					<spring:message code="member.town" />
				</form:label></td>
			<td width="75%" ><form:input path="town" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="county">
					<spring:message code="member.county" />
				</form:label></td>
			<td width="75%" ><form:input path="county" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="postcode">
					<spring:message code="member.postcode" />
				</form:label></td>
			<td><form:input path="postcode" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="country">
					<spring:message code="member.country" />
				</form:label></td>
			<td width="75%" ><form:input path="country" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="hilite">
					<spring:message code="member.hilite" />
				</form:label></td>
			<td width="75%" ><form:select path="hilite">
					<form:option selected="selected" value="Valid">Valid</form:option>
					<form:option value="Invalid">Invalid</form:option>
					<form:option value="Not Checked">Not Checked</form:option>
				</form:select></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="hiliteDateCleaned">
					<spring:message code="member.hiliteDateCleaned" />
				</form:label></td>
			<td width="75%" ><form:input path="hiliteDateCleaned" /></td>
		</tr>		
		<tr class="input">
			<td width="25%" ><form:label path="mobile">
					<spring:message code="member.mobile" />
				</form:label></td>
			<td width="75%" ><form:input path="mobile" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="mobileOptInForBets">
					<spring:message code="member.mobile_opt_in_for_bets" />
				</form:label></td>
			<td width="75%" ><form:checkbox path="mobileOptInForBets" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="mobileOptIn">
					<spring:message code="member.mobile_opt_in" />
				</form:label></td>
			<td width="75%" ><form:checkbox path="mobileOptIn" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="telephoneHome">
					<spring:message code="member.telephone_home" />
				</form:label></td>
			<td width="75%" ><form:input path="telephoneHome" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="email1">
					<spring:message code="member.email_1" />
				</form:label></td>
			<td width="75%" ><form:input path="email1" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="email1OptInBets">
					<spring:message code="member.email_1_opt_in_bets" />
				</form:label></td>
			<td><form:checkbox path="email1OptInBets" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="email1OptIn">
					<spring:message code="member.email_1_opt_in" />
				</form:label></td>
			<td width="75%" ><form:checkbox path="email1OptIn" /></td>
		</tr>
		<tr class="input">
			<td width="25%" ><form:label path="postalOptIn">
					<spring:message code="member.postal_opt_in" />
				</form:label></td>
			<td width="75%" ><form:checkbox path="postalOptIn" /></td>
		</tr>	
		<tr class="input">
			<td width="25%" ><form:label path="doubleOptIn">
					<spring:message code="member.double_opt_in" />
				</form:label></td>
			<td width="75%" ><form:checkbox path="doubleOptIn" /></td>
		</tr>				
		<tr class="input">
			<td width="25%" ><form:label path="service">
					<spring:message code="member.service" />
				</form:label></td>
			<td width="75%" ><form:select path="service" multiple="true" size="10px">
					<form:options items="${serviceList}" itemValue="serviceId"
						itemLabel="name" />
				</form:select></td>
		</tr>
		<tr class="input">
			<td width="25%" ></td>
			<td width="75%" ><input type="submit"
				value="<spring:message code="member.addmember"/>" /></td>
		</tr>
		<tr class="divider-bottom divider-top">
			<td width="100%" colspan="2"></td>
		</tr>
	</table>
</form:form>