<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">

<%@taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://displaytag.sf.net" prefix="display"%>


<c:if test="${!empty advices}">
	<table>
		<tr>
			<td><div id="heading">
					<spring:message code="list-service-advice.heading" />
					${service.name}
				</div></td>
		</tr>
		<tr>
			<td class="highlight">${report.reportDetails}</td>
		</tr>
		<tr>
			<td><display:table id="advice" export="true" name="advices"
					pagesize="25"
					requestURI="/list-service-advice-${report.type}-${service.serviceId}">
					<display:setProperty name="export.csv.filename"
						value="Full-Advice-List-For-Service-${service.shortCode}.csv" />
					<display:column class="content" headerClass="header" title="ID">
						<c:out value="${advice.adviceId}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Date">
						<c:out value="${advice.formattedCreated}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Course">
						<c:out value="${advice.course}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Time">
						<c:out value="${advice.time}" />
					</display:column>
					<display:column class="content" headerClass="header" title="No.">
						<c:out value="${advice.racecardNumber}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Bet">
						<c:out value="${advice.bet}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Market">
						<c:out value="${advice.market}" />
					</display:column>					
					<display:column class="content" headerClass="header"
						title="Bet Type">
						<c:out value="${advice.betType}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Odds">
						<c:out value="${advice.bestEarlyPriceEp}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Bookie">
						<c:out value="${advice.bestEpBookieExchange}" />
					</display:column>
					<display:column class="content" headerClass="header"
						title="BFSP-BSP">
						<c:out value="${advice.betfairStartingPriceBsp}" />
					</display:column>
					<display:column class="content" headerClass="header" title="Pos">
						<c:out value="${advice.finishingPosition}" />
					</display:column>
					<display:column class="content" headerClass="header" title="W/L">
						<c:out value="${advice.wonOrLost}" />
					</display:column>
					<display:column class="content" headerClass="header" title="LSP@AO">
						<c:out value="${advice.lsAtEp}" />
					</display:column>
					<display:column class="content" headerClass="header"
						title="LSP@BSP">
						<c:out value="${advice.lspAtBsp}" />
					</display:column>
					<display:column media="html" class="content" headerClass="header"
						title="Action">
						<a href="update-advice-${advice.adviceId}">Update</a> | 
						<a onclick="return shouldContinue()"
							href="delete-advice-${advice.adviceId}">Delete</a>							
					</display:column>
				</display:table></td>
		</tr>
	</table>
</c:if>

<c:if test="${empty advices}">
	<table>
		<tr>
			<td><div id="heading">
					<spring:message code="list-service-advice.empty" />
				</div></td>
		</tr>
	</table>
</c:if>