package uk.co.trinitylogic.skyfall.dao;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.assertEquals;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;

import org.hibernate.SessionFactory;
import org.hibernate.classic.Session;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import uk.co.trinitylogic.skyfall.form.Member;
import uk.co.trinitylogic.skyfall.form.Service;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration({ "file:src/test/resources/spring-test-context.xml" })
public class TestMemberDAOImpl {

	@Autowired
	private MemberDAO memberDAO;

	@Autowired
	private ServiceDAO serviceDAO;

	private SessionFactory factory;
	private Session session;

	@Before
	@Ignore
	public void setUp() {
		factory = createMock(SessionFactory.class);
		session = createMock(Session.class);
	}

	@Test
	@Ignore
	public void addServiceToMemberList() throws Exception {

		// 43 GENERAL ENQS - FULL 1ST NAME AND EMAIL
		// 44 GENERAL ENQS - NO 1ST NAME AND EMAIL
		// 45 GENERAL ENQS - PART NAME AND EMAIL
		// 46 GENERAL ENQS - PART NAME NO EMAIL

		List<Integer> ids = new ArrayList<Integer>();
		ids.add(new Integer(43));
		ids.add(new Integer(44));
		ids.add(new Integer(45));
		ids.add(new Integer(46));

		for (Integer id : ids) {
			String path = "C:\\Users\\jacksosa\\workspace\\Skyfall\\src\\test\\resources\\" + id + ".txt";
			File memberIds = new File(path);
			BufferedReader br = new BufferedReader(new FileReader(memberIds));

			String line = null;
			Service service = serviceDAO.getService(id);
			System.out.println(service);
			List<Integer> members = new ArrayList<Integer>();
			while ((line = br.readLine()) != null) {
				Integer memberId = new Integer(line);
				members.add(memberId);

			}
			br.close();
			for (Integer memberId : members) {
				System.out.println("Update memberId: " + memberId + " add service [" + id + "]");
				try {
					Member member = memberDAO.getMember(memberId);
					member.addService(service);
					memberDAO.updateMember(member);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}

	}

	@Test
	@Ignore
	public void testListDistinctMembersForServiceMatch() {
		//
		// Service one = new Service();
		// one.setServiceId(new Integer(1));
		// Service two = new Service();
		// two.setServiceId(new Integer(2));
		// Service three = new Service();
		// three.setServiceId(new Integer(3));
		// Service four = new Service();
		// four.setServiceId(new Integer(4));
		// Service five = new Service();
		// five.setServiceId(new Integer(5));
		// Service six = new Service();
		// six.setServiceId(new Integer(6));
		// Service seven = new Service();
		// seven.setServiceId(new Integer(7));
		//
		// Service eight = new Service();
		// eight.setServiceId(new Integer(8));
		// Service nine = new Service();
		// nine.setServiceId(new Integer(9));
		// Service ten = new Service();
		// ten.setServiceId(new Integer(10));
		// Service eleven = new Service();
		// eleven.setServiceId(new Integer(11));
		// Service twelve = new Service();
		// twelve.setServiceId(new Integer(12));
		// Service fourteen = new Service();
		// fourteen.setServiceId(new Integer(14));
		// Service fithteen = new Service();
		// fithteen.setServiceId(new Integer(15));
		// Service tweentyfour = new Service();
		// tweentyfour.setServiceId(new Integer(24));
		// 2, 4, 5, 6, 7, 8, 10, 11, 12, 13, 14, 15 and 24

		Service generalEnq = serviceDAO.getService(new Integer(17));

		List<Service> ser1 = new ArrayList<Service>();
		ser1.add(generalEnq);

		// ser1.add(one);
		// ser1.add(two);
		// ser1.add(three);
		// ser1.add(four);
		// ser1.add(five);
		// ser1.add(six);
		// ser1.add(seven);
		// ser1.add(eight);
		// ser1.add(nine);
		// ser1.add(ten);
		// ser1.add(eleven);
		// ser1.add(twelve);
		// ser1.add(fourteen);
		// ser1.add(fithteen);
		// ser1.add(tweentyfour);
		// List<Service> ser2 = new ArrayList<Service>();
		// ser2.add(one);
		// ser2.add(two);
		// ser2.add(three);
		// ser2.add(four);
		// ser2.add(five);
		// ser2.add(six);
		// ser2.add(seven);
		// ser2.add(eight);
		// ser2.add(nine);
		// ser2.add(ten);
		// ser2.add(eleven);
		// ser2.add(twelve);

		List<Member> list1 = memberDAO.listDistinctMembersForServiceList(ser1);
		List<Member> updateList = new ArrayList<Member>();
		for (Member m1 : list1) {
			if (m1.getService().size() > 1) {
				m1.removeService(generalEnq);
				memberDAO.updateMember(m1);
				updateList.add(m1);
			}
		}

		for (Member m1 : updateList) {
			System.out.println(m1.toCsvString());
		}

		// List<Member> list2 =
		// memberDAO.listDistinctMembersForServiceList(ser2);
		//
		// List<Member> match = new ArrayList<Member>();
		// List<Member> notmatch = new ArrayList<Member>();
		// boolean b = false;
		// for (Member m1 : list1) {
		// for (Member m2 : list2) {
		// if (m1.equals(m2)) {
		// match.add(m2);
		// b = true;
		// }
		// }
		// if (b != true) {
		// notmatch.add(m1);
		// } else {
		// b = false;
		// }
		// }
		//
		// List<Member> union = (List<Member>) CollectionUtils.union(list1,
		// list2);
		// List<Member> intersection = (List<Member>) CollectionUtils
		// .intersection(list1, list2);
		// List<Member> disjunction = (List<Member>)
		// CollectionUtils.disjunction(
		// list1, list2);

		// System.out.println("L1: " + list1.size() + "  L2: " + list2.size()
		// + "  M: " + match.size() + " UM: " + notmatch.size() + "  U: "
		// + union.size() + "  I: " + intersection.size() + "  D: "
		// + disjunction.size());
	}

	@Test
	@Ignore
	public void testGetMember() {
		Integer testMemberId = new Integer(1);
		Member testMember = new Member();
		testMember.setMemberId(testMemberId);
		testMember.setForename("Samuel");
		testMember.setSurname("Jackson");

		expect(factory.getCurrentSession()).andReturn(session);
		expect(session.get(Member.class, testMemberId)).andReturn(testMember);

		replay(factory, session);

		MemberDAOImpl dao = new MemberDAOImpl();
		// dao.setSessionFactory(factory);
		assertEquals(testMember, dao.getMember(testMemberId));

		verify(factory, session);

	}

	@Test
	@Ignore
	public void testSearchForMembers() throws Exception {
		List<Member> members;
		members = memberDAO.searchForMembers("447719840836");
		assertEquals(6, members.size());

		members = memberDAO.searchForMembers("Jackson");
		assertEquals(7, members.size());

	}
}
