package uk.co.trinitylogic.skyfall.form;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.junit.Before;
import org.junit.Test;

public class TestAdvice {

	private Advice advice;

	@Before
	public void before() {
		advice = new Advice();
	}

	@Test
	public void testSetAndGetAdviceId() {
		Integer testAdviceId = new Integer(1);
		assertNull(advice.getAdviceId());
		advice.setAdviceId(testAdviceId);
		assertEquals(testAdviceId, advice.getAdviceId());
	}

	@Test
	public void testGetCreated() {
		assertNotNull(advice.getCreated());
	}

	@Test
	public void testSetAndGetCourse() {
		String testCourse = "aCourse";
		assertNull(advice.getCourse());
		advice.setCourse(testCourse);
		assertEquals(testCourse, advice.getCourse());
	}

	@Test
	public void testSetAndGetTime() {
		String testTime = "aTime";
		assertNull(advice.getTime());
		advice.setTime(testTime);
		assertEquals(testTime, advice.getTime());
	}

	@Test
	public void testSetAndGetBet() {
		String testBet = "aBet";
		assertNull(advice.getBet());
		advice.setBet(testBet);
		assertEquals(testBet, advice.getBet());
	}

	@Test
	public void testSetAndGetBetType() {
		String testBetType = "aBetType";
		assertNull(advice.getBetType());
		advice.setBetType(testBetType);
		assertEquals(testBetType, advice.getBetType());
	}

	@Test
	public void testSetAndGetBestEarlyPriceEp() {
		String testBestEarlyPriceEp = "aBestEarlyPriceEp";
		assertNull(advice.getBestEarlyPriceEp());
		advice.setBestEarlyPriceEp(testBestEarlyPriceEp);
		assertEquals(testBestEarlyPriceEp, advice.getBestEarlyPriceEp());
	}

	@Test
	public void testSetAndGetBestEpBookieExchange() {
		String testBestEpBookieExchange = "aBestEpBookieExchange";
		assertNull(advice.getBestEpBookieExchange());
		advice.setBestEpBookieExchange(testBestEpBookieExchange);
		assertEquals(testBestEpBookieExchange, advice.getBestEpBookieExchange());
	}

	@Test
	public void testSetAndGetBetfairStartingPriceBsp() {
		String testBetfairStartingPriceBsp = "aBetfairStartingPriceBsp";
		assertNull(advice.getBetfairStartingPriceBsp());
		advice.setBetfairStartingPriceBsp(testBetfairStartingPriceBsp);
		assertEquals(testBetfairStartingPriceBsp,
				advice.getBetfairStartingPriceBsp());
	}

	@Test
	public void testSetAndGetFinishingPosition() {
		String testFinishingPosition = "aFinishingPosition";
		assertNull(advice.getFinishingPosition());
		advice.setFinishingPosition(testFinishingPosition);
		assertEquals(testFinishingPosition, advice.getFinishingPosition());
	}

	@Test
	public void testSetAndGetWonOrLost() {
		String testWonOrLost = "aWonOrLost";
		assertNull(advice.getWonOrLost());
		advice.setWonOrLost(testWonOrLost);
		assertEquals(testWonOrLost, advice.getWonOrLost());
	}

	@Test
	public void testSetAndGetLsAtEp() {
		String testLsAtEp = "aLsAtEp";
		assertNull(advice.getLsAtEp());
		advice.setLsAtEp(testLsAtEp);
		assertEquals(testLsAtEp, advice.getLsAtEp());
	}

	@Test
	public void testSetAndGetLspAtBsp() {
		String testLspAtBsp = "aLspAtBsp";
		assertNull(advice.getLspAtBsp());
		advice.setLspAtBsp(testLspAtBsp);
		assertEquals(testLspAtBsp, advice.getLspAtBsp());
	}

	@Test
	public void testSetAndGetRecommendedStake() {
		String testRecStake = "aRecommendedStake";
		assertNull(advice.getRecommendedStake());
		advice.setRecommendedStake(testRecStake);
		assertEquals(testRecStake, advice.getRecommendedStake());
	}

	@Test
	public void testSetAndGetService() {
		Service testService = new Service();
		assertNull(advice.getService());
		advice.setService(testService);
		assertEquals(testService, advice.getService());
	}

	@Test
	public void testToString() {

		Format formatter = new SimpleDateFormat("dd/MM/yy");

		Date testDate = new Date();
		Service testService = new Service();
		testService.setShortCode("aShortCode");
		advice.setService(testService);
		advice.setCourse("aRaceCourse");
		advice.setTime("aRaceTime");
		advice.setBet("aBet");
		advice.setBetType("aBetType");
		advice.setBestEarlyPriceEp("aBestEarlyPriceEp");
		advice.setBestEpBookieExchange("aBestEpBookieExchange");
		advice.setRacecardNumber("aRacecardNumber");
		String testToString = "["
				+ formatter.format(testDate)
				+ "] [aShortCode] [Aracecourse] [aRaceTime] [Abet] [aBetType] [aRacecardNumber] [aBestEarlyPriceEp] [aBestEpBookieExchange]";

		assertEquals(testToString, advice.toString());
	}

	@Test
	public void testEmailString() {
		Service testService = new Service();
		testService.setShortCode("aShortCode");
		advice.setService(testService);
		advice.setCourse("MUSSELBURGH");
		advice.setType("RACING");
		advice.setTime("14:10");
		advice.setBet("SYDNEY PAGET");
		advice.setBetType("WIN");
		advice.setBestEarlyPriceEp("2.88");
		advice.setBestEpBookieExchange("BVC");
		advice.setRacecardNumber("8");
		String testToString = "Musselburgh 14:10 #8 Sydney Paget 2.88 BVC";
		assertEquals(testToString, advice.emailString());
	}

	@Test
	public void testTextString() {
		Service testService = new Service();
		testService.setShortCode("aShortCode");
		advice.setService(testService);
		advice.setCourse("MUSSELBURGH");
		advice.setType("RACING");
		advice.setTime("14:10");
		advice.setBet("SYDNEY PAGET");
		advice.setBetType("WIN");
		advice.setBestEarlyPriceEp("2.88");
		advice.setBestEpBookieExchange("BVC");
		advice.setRacecardNumber("8");
		String testToString = "M 14:10 #8 Sydney Paget 2.88 BVC";
		assertEquals(testToString, advice.textString());
	}

}
