package uk.co.trinitylogic.skyfall.form;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;

import java.util.HashSet;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;

public class TestMember {

	private Member member;

	@Before
	public void before() {
		member = new Member();
	}

	@Test
	public void testSetAndGetMemberId() {
		Integer testMemberId = new Integer(1);
		assertNull(member.getMemberId());
		member.setMemberId(testMemberId);
		assertEquals(testMemberId, member.getMemberId());
	}

	@Test
	public void testSetAndGetTitle() {
		String testTitle = "aTitle";
		assertNull(member.getTitle());
		member.setTitle(testTitle);
		assertEquals(testTitle, member.getTitle());
	}

	@Test
	public void testSetAndGetForename() {
		String testForename = "aForename";
		assertNull(member.getForename());
		member.setForename(testForename);
		assertEquals(testForename, member.getForename());
	}

	@Test
	public void testSetAndGetMiddlename() {
		String testMiddlename = "aMiddlename";
		assertNull(member.getMiddlename());
		member.setMiddlename(testMiddlename);
		assertEquals(testMiddlename, member.getMiddlename());
	}

	@Test
	public void testSetAndGetSurname() {
		String testSurname = "aSurname";
		assertNull(member.getSurname());
		member.setSurname(testSurname);
		assertEquals(testSurname, member.getSurname());
	}

	@Test
	public void testSetAndGetAddress1() {
		String testAddress1 = "aAddress1";
		assertNull(member.getAddress1());
		member.setAddress1(testAddress1);
		assertEquals(testAddress1, member.getAddress1());
	}

	@Test
	public void testSetAndGetAddress2() {
		String testAddress2 = "aAddress2";
		assertNull(member.getAddress2());
		member.setAddress2(testAddress2);
		assertEquals(testAddress2, member.getAddress2());
	}

	@Test
	public void testSetAndGetTown() {
		String testTown = "aTown";
		assertNull(member.getTown());
		member.setTown(testTown);
		assertEquals(testTown, member.getTown());
	}

	@Test
	public void testSetAndGetCounty() {
		String testCounty = "aCounty";
		assertNull(member.getCounty());
		member.setCounty(testCounty);
		assertEquals(testCounty, member.getCounty());
	}

	@Test
	public void testSetAndGetPostcode() {
		String testPostcode = "aPostcode";
		assertNull(member.getPostcode());
		member.setPostcode(testPostcode);
		assertEquals(testPostcode, member.getPostcode());
	}

	@Test
	public void testSetAndGetCountry() {
		String testCountry = "aCountry";
		assertNull(member.getCountry());
		member.setCountry(testCountry);
		assertEquals(testCountry, member.getCountry());
	}

	@Test
	public void testSetAndGetHilite() {
		String testHilite = "aHilite";
		assertNull(member.getHilite());
		member.setHilite(testHilite);
		assertEquals(testHilite, member.getHilite());
	}

	@Test
	public void testSetAndTelephoneHome() {
		String testTelephoneHome = "aTelephoneHome";
		assertNull(member.getTelephoneHome());
		member.setTelephoneHome(testTelephoneHome);
		assertEquals(testTelephoneHome, member.getTelephoneHome());
	}

	@Test
	public void testSetAndTelephoneWork() {
		String testTelephoneWork = "aTelephoneWork";
		assertNull(member.getTelephoneWork());
		member.setTelephoneWork(testTelephoneWork);
		assertEquals(testTelephoneWork, member.getTelephoneWork());
	}

	@Test
	public void testSetAndGetEmail1() {
		String testEmail1 = "aEmail1";
		assertNull(member.getEmail1());
		member.setEmail1(testEmail1);
		assertEquals(testEmail1, member.getEmail1());
	}

	@Test
	public void testSetAndGetEmail2() {
		String testEmail2 = "aEmail2";
		assertNull(member.getEmail2());
		member.setEmail2(testEmail2);
		assertEquals(testEmail2, member.getEmail2());
	}

	@Test
	public void testSetAndGetMobile() {
		String testMobile = "aMobile";
		assertNull(member.getMobile());
		member.setMobile(testMobile);
		assertEquals(testMobile, member.getMobile());
	}

	@Test
	public void testSetAndGetMobileOptIn() {
		assertFalse(member.getMobileOptIn());
		member.setMobileOptIn(true);
		assertTrue(member.getMobileOptIn());
	}

	@Test
	public void testSetAndGetMobileOptInForBets() {
		assertFalse(member.getMobileOptInForBets());
		member.setMobileOptInForBets(true);
		assertTrue(member.getMobileOptInForBets());
	}

	@Test
	public void testSetAndGetEmail1OptInBets() {
		assertFalse(member.getEmail1OptInBets());
		member.setEmail1OptInBets(true);
		assertTrue(member.getEmail1OptInBets());
	}

	@Test
	public void testSetAndGetEmail2OptIn() {
		assertFalse(member.getEmail2OptIn());
		member.setEmail2OptIn(true);
		assertTrue(member.getEmail2OptIn());
	}

	@Test
	public void testSetAndGetService() {
		Set<Service> testServices = new HashSet<Service>();
		Service testService = new Service();
		testServices.add(testService);
		assertNull(member.getService());
		member.setService(testServices);
		assertEquals(testServices, member.getService());
	}

	@Test
	public void testToString() {
		String testToString = "null null null null null null";
		assertEquals(testToString, member.toString());
		testToString = "aTitle aForename aSurname aMobile aEmail1 [[1|aShortCode]]";
		Service testService = new Service();
		testService.setServiceId(new Integer(1));
		testService.setShortCode("aShortCode");
		member.setTitle("aTitle");
		member.setForename("aForename");
		member.setSurname("aSurname");
		member.setMobile("aMobile");
		member.setEmail1("aEmail1");
		Set<Service> testServices = new HashSet<Service>();
		testServices.add(testService);
		member.setService(testServices);
		assertEquals(testToString, member.toString());
	}
}
