package uk.co.trinitylogic.skyfall.service;

import static org.junit.Assert.assertEquals;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import uk.co.trinitylogic.skyfall.form.Advice;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration({ "file:src/test/resources/spring-test-context.xml" })
public class TestAdviceServiceImpl {

	@Autowired
	AdviceService adviceService;

	@Test
	public void testListDailyAdviceForServiceMonth() throws ParseException {
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date date = formatter.parse("2012-10-01 00:00:00");
		Integer serviceId = new Integer(3);
		List<Advice> advices = adviceService.listDailyAdviceForService(
				serviceId, date);
		assertEquals(3, advices.size());
	}

	@Test
	public void testListDailyAdviceForServiceDay() throws ParseException {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		Date date = cal.getTime();
		Integer serviceId = new Integer(3);
		List<Advice> advices = adviceService.listDailyAdviceForService(
				serviceId, date);
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		System.out.println(formatter.format(date));
		assertEquals(2, advices.size());
	}
}
