package uk.co.trinitylogic.skyfall.service;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration({ "file:src/test/resources/spring-test-context.xml" })
public class TestSendEmail {

	@Autowired
	private MailService mailService;
	private final String from = "matthew@matthewwalton.co.uk";
	private final String to1 = "samuel@trinitylogic.co.uk";
	private final String to2 = "peter@trinitylogic.co.uk";
	private final String to3 = "admin@trinitylogic.co.uk";
	private final String subject1 = "This is a test HTML message to Samuel";
	private final String subject2 = "This is a test message to Peter";
	private final String subject3 = "This is a test message to Admin";
	private final String body1 = "<html><body><h3>Test HTML Message</h3><p>Hoping you find this test message ok <div style=\"color:red;\">THIS SHOULD BE IN RED.</div></p></body></html>";
	private final String body2 = "Hi Peter, Congradulations you have recieved the test email.";
	private final String body3 = "Hi Admin, Congradulations you have recieved the test email.";
	private SimpleMailMessage message1;
	private SimpleMailMessage message2;
	private SimpleMailMessage message3;

	@Before
	public void createMailMessages() {
		message1 = new SimpleMailMessage();
		message1.setFrom(from);
		message1.setTo(to1);
		message1.setSubject(subject1);
		message1.setText(body1);
		message2 = new SimpleMailMessage();
		message2.setFrom(from);
		message2.setTo(to2);
		message2.setSubject(subject2);
		message2.setText(body2);
		message3 = new SimpleMailMessage();
		message3.setFrom(from);
		message3.setTo(to3);
		message3.setSubject(subject3);
		message3.setText(body3);
	}

	@Test
	public void testToSendHtmlMail() {
		mailService.sendHtmlMail(from, to1, subject1, body1);
		Assert.assertNotNull(mailService);
	}

	@Test
	@Ignore
	public void testToSendMail() {
		mailService.sendMail(from, to1, subject1, body1);
		Assert.assertNotNull(mailService);
	}

	@Test
	@Ignore
	public void testToSendSingleSimpleMailMessage() {
		mailService.sendMail(message1);
		Assert.assertNotNull(mailService);
	}

	@Test
	@Ignore
	public void testToSendMulipleSimpleMailMessage() {
		mailService.sendMail(message1, message2, message3);
		Assert.assertNotNull(mailService);
	}

}
